module TuringHS.ParserSpec where

import Test.Hspec
import TuringHS.Operator
import TuringHS.Parser

spec :: Spec
spec = do
  describe "parse" $ do
    it "should accept operators until reaching non-operator input" $ do
      let lineWithBadInput = ",.<>[]banana][.,>"
      parse lineWithBadInput `shouldBe` [Get, Put, Backward, Forward, JumpForward, JumpBackward]
    it "should accept operators from the start of lines until non-operator input" $ do
      let lines' =
            unlines
              [ ",.<>banana[],>>>>garbage",
                "[ maybe label where this goes",
                "  and then you can write a novel here...",
                "] that other jump comes here"
              ]
      parse lines' `shouldBe` [Get, Put, Backward, Forward, JumpForward, JumpBackward]
